#include "search.h"
#include "avx_utils.h"

void * search(char *s, size_t n){
    vector mask_a = load_mask('a');
    vector mask_b = load_mask('b');
    mask mod2= 0b10101010101010101010101010101010;
    for (size_t i = 0 ; i < n ; i += vector_size) {
        vector chunk = uload(s + i); 
        vector a_in_chunk = vectorEq(chunk, mask_a); 
        vector b_in_chunk = vectorEq(chunk, mask_b); 
        mask offset_a = maskFromVector(a_in_chunk);
        mask offset_b = maskFromVector(b_in_chunk);
        mask result = ((~offset_a) ^ mod2) | (offset_b^mod2);
        if ( result != 0 )  
            return (char *)(s + i + ctz(result));
    }
    return NULL;
}
