#include "search.h"
#include <avx_utils.h>
#define TRUE (char) 0b11111111
#define FALSE (char) 0b0000000

void * search(char *s, size_t n){
    vector va = load_mask('a');
    vector vb = load_mask('b');
    mask state = 0; 
    for (size_t i = 0 ; i < n ; i += vector_size) {
        vector chunk = uload(s + i); // load the chunk of the stream
        mask mask_a = maskFromVector(vectorEq(chunk, va)); 
        mask mask_b = maskFromVector(vectorEq(chunk, vb));
        mask shift_a = state | (mask_a << 1); //shift on the right;
        state = mask_a >> (vector_size - 1); //keep the first bit
        // ctz returns the offset of the left most 1 in mask
        mask offset = shift_a ^ mask_b; 
        if (offset != 0)  return (char *)(s + i + ctz(offset));
    }
    return NULL;
}
