#include "search.h"
#include "avx_utils.h"

void * search(char *s, size_t n){
    vector mask_a = load_mask('a');
    vector mask_b = load_mask('b');
    mask last_a = 0;
    mask last_b = 0;
    mask result_aa = 0;
    mask result_bb = 0;
    char carry1 = 0;
    char carry2 = 0;
    for (size_t i = 0 ; i < n ; i += vector_size) {
        vector chunk = uload(s + i); 
        mask offset_a = maskFromVector(vectorEq(chunk, mask_a));
        mask offset_b = maskFromVector(vectorEq(chunk, mask_b));
        mask aa = (offset_a << 1 | last_a) & offset_a;
        mask bb = (offset_b << 1 | last_b) & offset_b;
        mask ab = (offset_a << 1 | last_a) & offset_b;
        mask ba = (offset_b << 1 | last_b) & offset_a;
        carry1 = addcarry(carry1, (bb | ab), bb, &result_bb);
        carry2 = addcarry(carry2, (aa | ba), aa, &result_aa);
        mask result = (result_aa & aa) | (result_bb & bb);
        if (result > 0) 
            return (char*)(s + i + ctz(result));
        last_a = offset_a >> (vector_size -1);
        last_b = offset_b >> (vector_size -1);
        
    }
    return NULL;
}
