Requires Linux,  gcc and make to run.


To compile run:

```
make
```

It will build independant binaries for each implementation of `memchr`, `L1` and `L2` tasks.

For instance the following run the baseline for the `L1` task:

```
./L1/build/baseline
```

If you get the `Error creating event` is because you should have the right to measure 
perf event. This can be solved by running in `sudo` the binary or allowing 
for all user even monitoring by running

```
sudo bash -c "echo -1 >  /proc/sys/kernel/perf_event_paranoid"
```


You can add a novel implementation by adding a `c` file implementing `search`
in the appropriate folder.  You can change the input feeded to the implem by
changing `generate.c`.



```
.
├── L1
│   ├── generate.c
│   └── src
│       ├── abstar_avx2_mod.c
│       ├── abstar_avx2_shift.c
│       └── baseline.c
├── L2
│   ├── generate.c
│   └── src
│       ├── baseline.c
│       └── vect.c
├── lib
│   ├── avx_utils.h
│   ├── main.c
│   └── search.h
├── Makefile
├── memchr
│   ├── generate.c
│   └── src
│       ├── 8byte_search.c
│       ├── avx_memchr.c
│       ├── memchr_search.c
│       └── simple_search.c
└── README.md
```
