#ifndef __AVX_UTILS_H__
#define __AVX_UTILS_H__

#include <immintrin.h>
#include <x86intrin.h>
#include <stdio.h>
#include <stdint.h>

#define vector __m256i
#define mask uint32_t
#define double_mask long long unsigned int
#define vector_size 32
#define last_vector_position 31
#define vector_or _mm256_or_si256
#define vector_and _mm256_and_si256
#define vector_andnot _mm256_andnot_si256
#define vector_gt _mm256_cmpgt_epi8
#define vectorEq _mm256_cmpeq_epi8
#define maskFromVector(A) _mm256_movemask_epi8((A))
#define permut4x64 _mm256_permute4x64_epi64
#define blend _mm256_blendv_epi8

#define load_mask _mm256_set1_epi8
#define load(X) _mm256_stream_load_si256( (vector * )(X))
#define uload(X) _mm256_loadu_si256( (vector * )(X))
#define save_vector(X, Y) _mm256_storeu_si256((X), (Y))
#define apply_mask(A, B) mask_from_vector(vector_eq((A), (B)))

#define ctz(x) __builtin_ctz(x)
#define clz(x) __builtin_clz(x)
#define ctzll(x) __builtin_ctzll(x)
#define clzll(x) __builtin_clzll(x)
#define popcount __builtin_popcount
#define addcarry _addcarry_u32
#define addcarry_double _addcarry_u64
#define add_type mask
#ifdef __GNUC__
  #define ALIGN(x) x __attribute__((aligned(32)))
#elif defined(_MSC_VER)
  #define ALIGN(x) __declspec(align(32))
#endif
#endif

void printBits(mask t)
{
    printf("vector:");
    for (size_t i=0; i<vector_size; i++) {
        if (t%2 == 1)
            printf("1");
        else
            printf("0");
        t = t / 2;
    }
    printf("\n");
}
