#include "search.h"
#include "avx_utils.h"
#include <immintrin.h> // intel intrinsics header
#define value 1

void *  search(char * buffer, size_t length){
    __m256i * cast_buffer = (__m256i *) buffer;
    __m256i mask = _mm256_set1_epi8(value);
    __m256i A, B; int packed_return;
    for (size_t i=0; i<length/32; i++){
        A = _mm256_load_si256(cast_buffer + i);
        //load buffer in register
        B = _mm256_cmpeq_epi8(A, mask);
        // compare with the mask
        packed_return  = _mm256_movemask_epi8(B);
        if (packed_return)
            return buffer + 32*i +
                 __builtin_ctz(packed_return);
    }
    return NULL;
}
